import { IBuildable, ICleanable, IErrors, IResetable, IState, IValues, ObjectProperties, ObjectValues } from './types';
export declare class ObjectState<TObject> implements IState, ICleanable, IResetable, IBuildable<TObject>, IValues<TObject>, IErrors {
    properties: ObjectProperties<TObject>;
    get isDirty(): boolean;
    get errors(): string[];
    set errors(errors: string[]);
    get hasErrors(): boolean;
    get values(): ObjectValues<TObject>;
    constructor(obj: TObject);
    build(): TObject;
    clean(): void;
    reset(): void;
    clearErrors(): void;
}
